<?php
defined('_JEXEC') or die('Restricted access');


class pm_cashbill extends PaymentRoot{
    
    private $version = '1.3.0';
    
    function showPaymentForm($params, $pmconfigs){
        include(dirname(__FILE__)."/paymentform.php");
    }
    
    function showAdminFormParams($params){
        $array_params = array('cashbill_user_id', 'cashbill_user_key', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
        foreach ($array_params as $key){
            if (!isset($params[$key])) $params[$key] = '';
        }
        $orders = JModelLegacy::getInstance('orders', 'JshoppingModel');
        
        include(dirname(__FILE__)."/adminparamsform.php");
        echo $this->checkVersion();
    }    
    
    function complete($pmconfigs, $order, $payment) {
        if ($order->order_status == '1'){
            $checkout = JModelLegacy::getInstance('checkout', 'jshop');
            $checkout->changeStatusOrder($order->order_id, $pmconfigs['transaction_pending_status'], 0);
            return;
        } else
            return;
    }

    function checkSignature($data,$key,$sign){
        if(md5($data['service'].$data['orderid'].$data['amount'].$data['userdata'].$data['status'].$key) === $sign){
            return true;
        }

        if(md5($data['service'].'|'.$data['orderid'].'|'.$data['amount'].'|'.$data['userdata'].'|'.$data['status'].'|'.$key) === $sign){
            return true;
        }

        return false;
    }
    
    function checkTransaction($pmconfigs, $order, $act){
        $cashbill_userkey = $pmconfigs['cashbill_user_key'];
        if($this->checkSignature($_POST,$cashbill_userkey,$_POST['sign']))
        {
            if(strtoupper($_POST['status']) == 'OK')
            {
                $checkout = JModelLegacy::getInstance('checkout', 'jshop');
                $checkout->changeStatusOrder($order->order_id, $pmconfigs['transaction_end_status'], 0);
                
            }else
            {
                $checkout = JModelLegacy::getInstance('checkout', 'jshop');
                $checkout->changeStatusOrder($order->order_id, $pmconfigs['transaction_failed_status'], 0);
            }
           echo 'OK';
           exit();    
        }
        echo 'BLAD SYGNATURY';
    }

    function showEndForm($pmconfigs, $order){
    $jshopConfig = JSFactory::getConfig();
    $item_name = sprintf(_JSHOP_PAYMENT_NUMBER, $order->order_number);
    $_country = JSFactory::getTable('country', 'jshop');
    $_country->load($order->d_country);
    $country = $_country->country_code_2;
    $order->order_total = $this->fixOrderTotal($order);
    
    $hidden = array();
    
    $hidden = array(
        'service'=>$pmconfigs['cashbill_user_id'],
        'amount'=>$order->order_total,
        'currency' => "PLN",
        'desc'=>'Zamówienie nr : '.$order->order_id,
        'lang' => "",
        'userdata'=>$order->order_id,
        'ref' => 'JoomShopping',
        'forname'=>$order->d_f_name,
        'surname'=>$order->d_l_name,
        'email'=>$order->email,
        'tel' => "",
        'street'=>$order->d_street,
        'street_n1'=>"",
        'street_n2'=>"",
        'city'=>$order->d_city,
        'postcode'=>$order->d_zip,
        'country'=>$country,
    );
    
    $hidden['sign'] = md5(implode('|',$hidden).'|'.$pmconfigs['cashbill_user_key']);
    
    $html = '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>
    <form id="paymentform" action="https://pay.cashbill.pl/form/pay.php" name = "paymentform" method = "post">';
    foreach($hidden as $key => $value)
    {
    $html .= '<input type="hidden" name="'.$key.'" value="'.$value.'">';    
    }
    $html .= '<script type="text/javascript">document.getElementById(\'paymentform\').submit();</script></body></html>';
    
    echo $html;
    
    exit();
    }
    
    function getUrlParams($pmconfigs){
        $params = array();
        $params['order_id'] = $_POST['userdata'];
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['$checkReturnParams'] = 0;
        return $params;
    }
    
    function fixOrderTotal($order){
        $total = $order->order_total;
        if ($order->currency_code_iso=='PLN'){
            return number_format($total, 2, '.', '');
        }else{
        exit('Waluta nie PLN');    
        }
        return $total;
    }

    public function checkVersion()
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "http://devel.cashbill.pl/lukasz/www/ajax/module-version-checker.php?cmd=info&module=JoomShopping");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $response = curl_exec($ch);
        curl_close($ch);
        
        $response = json_decode($response);
        
        if (empty($response)) {
            
            return '';
        }
        
        if ($response->version == $this->version) {
            return '<p style="text-align:center;">Posiadasz najnowszą wersję modułu płatności CashBill dla ' . $response->name . '</p>';
        }
        
        return '<p style="text-align:center;">Aktualnie posiadasz wersję ' . $this->version . ' jednak jest już dostępna nowsza wersja ' . $response->version . '.</p><p style="text-align:center;"> Możesz ją pobrać korzystając z tego linku <a href="http://www.cashbill.pl/' . $response->link . '">moduł dla ' . $response->name . ' w wersji ' . $response->version . '</a><p>';
    }
    
}